<template>
  <div>
    <b-form-group
      label-cols="12"
      label-cols-sm="12"
      label-cols-md="12"
      label-cols-lg="12"
      label-cols-xl="12"
      :label="label"
      :label-for="input_id"
    >
      <b-form-select
        :id="input_id"
        :label="label"
        v-bind:value="value"
        v-on:change="onFilterChange"
        :options="availShippingStatuses"
        value-field="pk"
        text-field="name"
      >
        <template v-slot:first>
          <option :value="null">Todo</option>
        </template>
      </b-form-select>
    </b-form-group>
  </div>

</template>

<script>
import { mapState, mapActions } from "vuex";

export default {
  name: "v-shipping-status-filter",
  props: {
    label: {
      type: String,
      default: "Status"
    },
    value: undefined
  },
  data() {
    return {
      input_id: "shipping-select"
    };
  },
  computed: {
    ...mapState({
      availShippingStatuses: state => state.utils.availShippingStatuses
    })
  },
  mounted() {
    this.input_id = this.$_.uniqueId("shipping-select-");
    if (!this.availShippingStatuses) {
      this.LOAD_AVAIL_SHIPPING_STATUSES();
    }
  },
  methods: {
    ...mapActions({
      LOAD_AVAIL_SHIPPING_STATUSES: "utils/LOAD_AVAIL_SHIPPING_STATUSES"
    }),
    onFilterChange(value) {
      this.$emit("input", value);
      this.$emit("change", value);
    }
  }
};
</script>
<style scoped lang="scss">
</style>
